/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package tp2;

import java.util.List;
import javax.ejb.Stateful;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.Query;

/**
 *
 * @author max06
 */
@Stateful
public class BankBean implements BankLocal {
    @PersistenceContext
    private EntityManager em;
    private Account account = null;

    public void persist(Object object) {
        em.persist(object);
    }
    
    // Add business logic below. (Right-click in editor and choose
    // "Insert Code > Add Business Method" or "Web Service > Add Operation")
    public Account openAccount(String ownerName, int amount){
        account = new Account();
        account.setOwnerName(ownerName);
        account.setBalance(amount);
        em.persist(account);
        return account;
    }

    public boolean closeAccount(int accountNumber){
        Account account = em.find(Account.class, accountNumber);
        if(account != null){
            em.remove(account);
            return true;
        }
        else return false;
            
    }

    public List<Account> getAllAccounts(){
        Query query = em.createNamedQuery("Account.findAll");
        return query.getResultList();
    }

    public List<BankingOperation> getAllBankingOperations(){
        Query query = em.createNamedQuery("BankingOperation.findAll");
        return query.getResultList();
    }

    public int getBalance(){
        if(account == null){
            throw new IllegalStateException();
        }
        else return account.getBalance();
    }

    public void deposit (int amount){
        if(account == null){
            throw new IllegalStateException();
        }
        else account.deposit(amount);
    }

    public void withDraw (int amount){
        if(account == null){
            throw new IllegalStateException();
        }
        else account.withDraw(amount);
    }

    public void createTestAccounts(){
        openAccount("John", 3000);
        openAccount("Paul", 3000);
        openAccount("Georges", 3000);
        openAccount("Ringo", 3000);
    }

    public boolean accountTransfer(int amount, int accountNumber1, int accountNumber2){
        Account account1 = em.find(Account.class, accountNumber1);
        Account account2 = em.find(Account.class, accountNumber2);
        int tmp = account1.withDraw(amount);
        if(tmp > 0){
            account2.deposit(amount);
            return true;
        }
        else
            return false;

    }
 
}
