/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package tp2;

import java.util.Date;
import javax.ejb.ActivationConfigProperty;
import javax.ejb.MessageDriven;
import javax.jms.JMSException;
import javax.jms.Message;
import javax.jms.MessageListener;
import javax.jms.ObjectMessage;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;

/**
 *
 * @author max06
 */
@MessageDriven(mappedName = "jms/BankingOperation", activationConfig =  {
        @ActivationConfigProperty(propertyName = "acknowledgeMode", propertyValue = "Auto-acknowledge"),
        @ActivationConfigProperty(propertyName = "destinationType", propertyValue = "javax.jms.Topic"),
        @ActivationConfigProperty(propertyName = "subscriptionDurability", propertyValue = "Durable"),
        @ActivationConfigProperty(propertyName = "clientId", propertyValue = "BankingOperationBean"),
        @ActivationConfigProperty(propertyName = "subscriptionName", propertyValue = "BankingOperationBean")
    })
public class BankingOperationBean implements MessageListener {
    @PersistenceContext
    private EntityManager em;

    public BankingOperationBean() {
    }


    public void onMessage(Message msg) {
        if(msg instanceof ObjectMessage) {
            ObjectMessage om = (ObjectMessage) msg;
           try {
              BankingOperation bankingOperation = (BankingOperation) om.getObject();
              bankingOperation.setDate1(new Date());
              persist(bankingOperation);
            } catch (JMSException e) {
              e.printStackTrace();
            }
        }
    }

    public void persist(Object object) {
        em.persist(object);
    }
  
}
