/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package tp2;

import java.io.IOException;
import java.io.PrintWriter;
import java.io.Serializable;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.annotation.Resource;
import javax.ejb.EJB;
import javax.jms.Connection;
import javax.jms.ConnectionFactory;
import javax.jms.JMSException;
import javax.jms.Message;
import javax.jms.MessageProducer;
import javax.jms.ObjectMessage;
import javax.jms.Session;
import javax.jms.Topic;
import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 *
 * @author max06
 */
public class AccountServlet extends HttpServlet {
    @Resource(name = "jms/BankingOperation")
    private Topic bankingOperation;
    @Resource(name = "jms/BankingOperationFactory")
    private ConnectionFactory bankingOperationFactory;
    @EJB
    private BankLocal bankBean;
   
    /** 
     * Processes requests for both HTTP <code>GET</code> and <code>POST</code> methods.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        response.setContentType("text/xml;charset=UTF-8");
        PrintWriter out = response.getWriter();
        try {
            List accounts = bankBean.getAllAccounts();
            List bankingOperations = bankBean.getAllBankingOperations();
            if(request.getParameter("action") != null){
                
                if(request.getParameter("action").equals("openAccount")){
                    String owner;
                    int balance;
                    try{
                        balance = Integer.parseInt(request.getParameter("balance"));
                        owner = request.getParameter("owner");
                        bankBean.openAccount(owner, balance);
                        BankingOperationUpdate("Ouverture de compte", "", balance);
                        out.write("<valid>true</valid>");
                    }
                    catch(Exception e){
                        out.write("<valid>false</valid>");
                    }
                }
                if(request.getParameter("action").equals("closeAccount")){
                    int accountNumber;
                    try{
                        accountNumber = Integer.parseInt(request.getParameter("accountNumber"));
                        boolean success = bankBean.closeAccount(accountNumber);
                        if(success){
                             BankingOperationUpdate("Fermeture de compte", "", 0);
                             out.write("<valid>true</valid>");
                        }
                        else
                            out.write("<valid>false</valid>");
                        
                    }
                    catch(Exception e){
                        out.write("<valid>false</valid>");
                    }

                }
                if(request.getParameter("action").equals("accountTransfer")){
                    int amount;
                    int accountNumber1;
                    int accountNumber2;
                    //try{
                        amount = Integer.parseInt(request.getParameter("amount"));
                        accountNumber1 = Integer.parseInt(request.getParameter("accountD"));
                        accountNumber2 = Integer.parseInt(request.getParameter("accountC"));
                        boolean success = bankBean.accountTransfer(amount, accountNumber1, accountNumber2);
                        BankingOperationUpdate("Transfert de compte", "Debit", -amount);
                        BankingOperationUpdate("Transfert de compte", "Credit", amount);
                        out.write("<valid>" + success +"</valid>");
                    //}
                    //catch(Exception e){
                      //  out.write("<valid>false</valid>");
                    //}
                    
                }
                if(request.getParameter("action").equals("open")){
                    request.setAttribute("Accounts", accounts);
                    RequestDispatcher dp = request.getRequestDispatcher("openAccount.jsp");
                    dp.forward(request, response);
                }
                if(request.getParameter("action").equals("close")){
                    request.setAttribute("Accounts", accounts);
                    RequestDispatcher dp = request.getRequestDispatcher("closeAccount.jsp");
                    dp.forward(request, response);
                }
                if(request.getParameter("action").equals("show")){
                    request.setAttribute("Accounts", accounts);
                    RequestDispatcher dp = request.getRequestDispatcher("showAccounts.jsp");
                    dp.forward(request, response);
                }
                if(request.getParameter("action").equals("transfer")){
                    request.setAttribute("Accounts", accounts);
                    RequestDispatcher dp = request.getRequestDispatcher("accountTransfer.jsp");
                    dp.forward(request, response);
                }
                if(request.getParameter("action").equals("banking")){
                    request.setAttribute("BankingOperations", bankingOperations);
                    RequestDispatcher dp = request.getRequestDispatcher("showBankingOperations.jsp");
                    dp.forward(request, response);
                }
            }
            else{
                accounts = bankBean.getAllAccounts();
                request.setAttribute("Accounts", accounts);
                RequestDispatcher dp = request.getRequestDispatcher("index.jsp");
                dp.forward(request, response);
            }
            
        } finally { 
            out.close();
        }
    }

    public void BankingOperationUpdate(String description, String type, int amount){
        try {
            BankingOperation bankingOperation = new BankingOperation();
            bankingOperation.setDescription(description);
            bankingOperation.setType(type);
            bankingOperation.setAmount(amount);
            sendJMSMessageToBankingOperation(bankingOperation);
        } catch (JMSException ex) {
            Logger.getLogger(AccountServlet.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /** 
     * Handles the HTTP <code>GET</code> method.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        processRequest(request, response);
    } 

    /** 
     * Handles the HTTP <code>POST</code> method.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        processRequest(request, response);
    }

    /** 
     * Returns a short description of the servlet.
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>

    private Message createJMSMessageForjmsBankingOperation(Session session, Object messageData) throws JMSException {
        // TODO create and populate message to send
        ObjectMessage om = session.createObjectMessage();;
        om.setObject((Serializable) messageData);
        return om;
    }

    private void sendJMSMessageToBankingOperation(Object messageData) throws JMSException {
        Connection connection = null;
        Session session = null;
        try {
            connection = bankingOperationFactory.createConnection();
            session = connection.createSession(false, Session.AUTO_ACKNOWLEDGE);
            MessageProducer messageProducer = session.createProducer(bankingOperation);
            messageProducer.send(createJMSMessageForjmsBankingOperation(session, messageData));
        } finally {
            if (session != null) {
                try {
                    session.close();
                } catch (JMSException e) {
                    Logger.getLogger(this.getClass().getName()).log(Level.WARNING, "Cannot close session", e);
                }
            }
            if (connection != null) {
                connection.close();
            }
        }
    }

}
